/* run.config
   DONTRUN: backward goto
*/
/* Generated by CIL v. 1.3.6 */
/* print_CIL_Input is false */

int status  = 0;
int rr  = 1;
/*@ global invariant inv: ((0 <= rr) && (rr <= 5000));

*/
//****************
//* BEGIN Primitives generated for LTL verification
//* 
//* States and Trans Variables
int buch_CurStates[7]  = {0, 1, 0, 0, 0, 0, 0};
int buch_CurTrans[7]  = {1, 0, 0, 0, 0, 0, 0};
int buch_CurStates_old[7]  = {1, 0, 0, 0, 0, 0, 0};
int buch_CurTrans_tmp[7]  = {1, 0, 0, 0, 0, 0, 0};
//* 
//* Their invariants
/*@
global
invariant Buch_Ranges_Validity:
                               (\valid(buch_CurTrans + (0 .. 6)) &&
                               (\valid(buch_CurTrans_tmp + (0 .. 6)) &&
                               (\valid(buch_CurStates + (0 .. 6)) &&
                               \valid(buch_CurStates_old + (0 .. 6)))));
 */
/*@
global
invariant Buch_Arrays_Coherence:
                                (\forall integer _buch_i;
                                (((0 <= _buch_i) && (_buch_i < 7)) ==>
                                (buch_CurTrans[_buch_i] ==
                                buch_CurTrans_tmp[_buch_i])));

*/
//* 
//* Acceptation States -- UNUSED AT THIS TIME !!!
int buch_AcceptStates[7]  = {1, 0, 0, 0, 0, 0, 1};
/*@
global
invariant Buch_acc_Ranges_Validity: \valid(buch_AcceptStates + (0 .. 6));

*/
//* 
//* Some constants
enum buch_ListOper {
    op_main = 0,
    op_opc = 1,
    op_opb = 2,
    op_opa = 3
} ;
enum buch_ListOper buch_CurOperation  = op_main;
enum Buch_OpStatusList {
    buch_Called = 0,
    buch_Terminated = 1
} ;
enum Buch_OpStatusList buch_CurOpStatus  = buch_Called;
//* 
//* Loops management
//* 
//**************** 
/*@ axiomatic transitions_automata {
  @ logic integer buch_Trans_Start(integer tr);
  @ axiom buch_Trans_Start0: (buch_Trans_Start(0) == 0);
  @ axiom buch_Trans_Start1: (buch_Trans_Start(1) == 1);
 @ axiom buch_Trans_Start2: (buch_Trans_Start(2) == 2);
 @ axiom buch_Trans_Start3: (buch_Trans_Start(3) == 3);
 @ axiom buch_Trans_Start4: (buch_Trans_Start(4) == 4);
 @ axiom buch_Trans_Start5: (buch_Trans_Start(5) == 5);
 @ axiom buch_Trans_Start6: (buch_Trans_Start(6) == 6);
 @ logic integer buch_Trans_Stop(integer tr);
 @ axiom buch_Trans_Stop0: (buch_Trans_Stop(0) == 1);
 @ axiom buch_Trans_Stop1: (buch_Trans_Stop(1) == 2);
 @ axiom buch_Trans_Stop2: (buch_Trans_Stop(2) == 3);
 @ axiom buch_Trans_Stop3: (buch_Trans_Stop(3) == 4);
 @ axiom buch_Trans_Stop4: (buch_Trans_Stop(4) == 5);
 @ axiom buch_Trans_Stop5: (buch_Trans_Stop(5) == 6);
 @ axiom buch_Trans_Stop6: (buch_Trans_Stop(6) == 6);
 @ }
 @*/

/*@
predicate buch_Trans_Cond_param{L}(integer _buch_numTrans, integer _buch_op,
                                  integer _buch_status)
         =
         (((_buch_numTrans == 0) ==>
          ((_buch_op == op_main) && (_buch_status == buch_Called)))
         &&
         (((_buch_numTrans == 1) ==>
          ((_buch_op == op_opa) && (_buch_status == buch_Called)))
         &&
         (((_buch_numTrans == 2) ==>
          !(((_buch_op == op_opb) && (_buch_status == buch_Terminated))))
         &&
         (((_buch_numTrans == 3) ==>
          !(((_buch_op == op_opa) && (_buch_status == buch_Called))))
         &&
         (((_buch_numTrans == 4) ==>
          ((_buch_op == op_opb) && (_buch_status == buch_Terminated)))
         &&
         (((_buch_numTrans == 5) ==>
          ((_buch_op == op_main) && (_buch_status == buch_Terminated)))
         && ((_buch_numTrans == 6) ==> \true)))))));
 */
/*@
predicate buch_Trans_Cond{L}(integer _buch_numTrans) =
         buch_Trans_Cond_param{L}(_buch_numTrans, buch_CurOperation,
                                 buch_CurOpStatus);

*/
//* 
//**************** 
//* Safety invariants
//* 
//* Inv 1 : Each active state is reachable
/*@
global
invariant _Buch_st_reach_1:
                           (\forall integer _buch_st;
                           ((((0 <= _buch_st) && (_buch_st < 7)) &&
                            (\forall integer _buch_tr;
                            (((0 <= _buch_tr) && (_buch_tr < 7)) ==>
                            ((buch_CurTrans[_buch_tr] == 0) ||
                            ((buch_Trans_Stop(_buch_tr) != _buch_st) ||
                            (!(buch_Trans_Cond(_buch_tr)) ||
                            (buch_CurStates_old[buch_Trans_Start(_buch_tr)] ==
                            0)))))))
                           ==> (buch_CurStates[_buch_st] == 0)));
 */
//* Inv 2 : Each non-active state is not reachable
/*@
global
invariant _Buch_st_reach_2:
                           (\forall integer _buch_st;
                           ((((0 <= _buch_st) && (_buch_st < 7)) &&
                            (buch_CurStates[_buch_st] == 0))
                           ==>
                           (\forall integer _buch_tr;
                           (((0 <= _buch_tr) && (_buch_tr < 7)) ==>
                           ((buch_CurTrans[_buch_tr] == 0) ||
                           ((buch_Trans_Stop(_buch_tr) != _buch_st) ||
                           (!(buch_Trans_Cond(_buch_tr)) ||
                           (buch_CurStates_old[buch_Trans_Start(_buch_tr)] ==
                           0))))))));
 */
//* Inv 3 : Each active state is reachable
/*@
global
invariant _Buch_st_reach_3:
                           (\forall integer _buch_st;
                           ((((0 <= _buch_st) && (_buch_st < 7)) &&
                            (buch_CurStates[_buch_st] != 0))
                           ==>
                           (\exists integer _buch_tr;
                           (((0 <= _buch_tr) && (_buch_tr < 7)) &&
                           ((buch_CurTrans[_buch_tr] != 0) &&
                           (buch_Trans_Cond(_buch_tr) &&
                           ((buch_Trans_Stop(_buch_tr) == _buch_st) &&
                           (buch_CurStates_old[buch_Trans_Start(_buch_tr)] !=
                           0))))))));
 */
//* Inv 4 : Each transition annotated as crossable is crossable
/*@
global
invariant _Buch_tr_cross_1:
                           (\forall integer _buch_tr;
                           ((((0 <= _buch_tr) && (_buch_tr < 7)) &&
                            (buch_CurTrans[_buch_tr] != 0))
                           ==>
                           (buch_Trans_Cond(_buch_tr) &&
                           ((buch_CurStates_old[buch_Trans_Start(_buch_tr)] !=
                            0)
                           &&
                           (buch_CurStates[buch_Trans_Stop(_buch_tr)] != 0)))));
 */
//* Inv 5 : Each crossable transition is crossed
/*@
global
invariant _Buch_tr_cross_2:
                           (\forall integer _buch_tr;
                           ((((0 <= _buch_tr) && (_buch_tr < 7)) &&
                            ((buch_CurStates_old[buch_Trans_Start(_buch_tr)]
                             != 0)
                            && buch_Trans_Cond(_buch_tr)))
                           ==>
                           ((buch_CurTrans[_buch_tr] != 0) &&
                           (buch_CurStates[buch_Trans_Stop(_buch_tr)] != 0))));
 */
//* Inv 6 : Non-crossable transitions are not crossed over
/*@
global
invariant _Buch_tr_cross_3:
                           (\forall integer _buch_tr;
                           ((((0 <= _buch_tr) && (_buch_tr < 7)) &&
                            ((buch_CurStates_old[buch_Trans_Start(_buch_tr)]
                             != 0)
                            || !(buch_Trans_Cond(_buch_tr))))
                           ==> (buch_CurTrans[_buch_tr] != 0)));

*/
//* 
//* END Primitives generated for LTL verification
//****************
/*@ requires ((((((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[2])) &&
                (0 == buch_CurTrans[3]))
               && (0 == buch_CurTrans[4]))
              && (0 == buch_CurTrans[5]))
             && (0 == buch_CurTrans[6]));
    requires (0 != buch_CurTrans[1]);
    requires ((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[1])) &&
                (0 == buch_CurStates[3]))
               && (0 == buch_CurStates[4]))
              && (0 == buch_CurStates[5]))
             && (0 == buch_CurStates[6]));
    requires (0 != buch_CurStates[2]);
    requires (rr < 5000);
    behavior Buchi_property_behavior_2:
      assumes (0 != buch_CurStates[2]);
      ensures ((((((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1])) &&
                 (0 == buch_CurTrans[3]))
                && (0 == buch_CurTrans[4]))
               && (0 == buch_CurTrans[5]))
              && (0 == buch_CurTrans[6]));
      ensures (0 != buch_CurTrans[2]);
      ensures ((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[1])) &&
                 (0 == buch_CurStates[2]))
                && (0 == buch_CurStates[4]))
               && (0 == buch_CurStates[5]))
              && (0 == buch_CurStates[6]));
      ensures (0 != buch_CurStates[3]);
      
    behavior j:
      ensures (rr < 5001);
      */
void opa(void) 
{ 
  
  {rr ++;
  {buch_CurOperation = op_opa;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  return;}
  }

}
/*@ requires ((((((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1])) &&
                (0 == buch_CurTrans[2]))
               && (0 == buch_CurTrans[4]))
              && (0 == buch_CurTrans[5]))
             && (0 == buch_CurTrans[6]));
    requires (0 != buch_CurTrans[3]);
    requires ((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[1])) &&
                (0 == buch_CurStates[2]))
               && (0 == buch_CurStates[3]))
              && (0 == buch_CurStates[5]))
             && (0 == buch_CurStates[6]));
    requires (0 != buch_CurStates[4]);
    behavior Buchi_property_behavior_4:
      assumes (0 != buch_CurStates[4]);
      ensures ((((((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1])) &&
                 (0 == buch_CurTrans[2]))
                && (0 == buch_CurTrans[3]))
               && (0 == buch_CurTrans[5]))
              && (0 == buch_CurTrans[6]));
      ensures (0 != buch_CurTrans[4]);
      ensures ((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[1])) &&
                 (0 == buch_CurStates[2]))
                && (0 == buch_CurStates[3]))
               && (0 == buch_CurStates[4]))
              && (0 == buch_CurStates[6]));
      ensures (0 != buch_CurStates[5]);
      */
void opb(void) 
{ 
  
  {status = 1;
  {buch_CurOperation = op_opb;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = buch_CurStates_old[4];
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = 0;
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = 0;
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = buch_CurStates_old[4];
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  return;}
  }

}
/*@ requires (((((((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1])) &&
                 (0 == buch_CurTrans[2]))
                && (0 == buch_CurTrans[3]))
               && (0 == buch_CurTrans[4]))
              && (0 == buch_CurTrans[5]))
             && (0 == buch_CurTrans[6]));
    requires \false;
    requires (((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[1])) &&
                 (0 == buch_CurStates[2]))
                && (0 == buch_CurStates[3]))
               && (0 == buch_CurStates[4]))
              && (0 == buch_CurStates[5]))
             && (0 == buch_CurStates[6]));
    requires \false;
    */
void opc(void) 
{ 
  
  {rr = 60000;
  {buch_CurOperation = op_opc;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  return;}
  }

}
/*@ requires ((((((0 == buch_CurTrans[1]) && (0 == buch_CurTrans[2])) &&
                (0 == buch_CurTrans[3]))
               && (0 == buch_CurTrans[4]))
              && (0 == buch_CurTrans[5]))
             && (0 == buch_CurTrans[6]));
    requires (0 != buch_CurTrans[0]);
    requires ((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[2])) &&
                (0 == buch_CurStates[3]))
               && (0 == buch_CurStates[4]))
              && (0 == buch_CurStates[5]))
             && (0 == buch_CurStates[6]));
    requires (0 != buch_CurStates[1]);
    behavior Buchi_property_behavior_1:
      assumes (0 != buch_CurStates[1]);
      ensures ((((((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1])) &&
                 (0 == buch_CurTrans[2]))
                && (0 == buch_CurTrans[3]))
               && (0 == buch_CurTrans[4]))
              && (0 == buch_CurTrans[6]));
      ensures (0 != buch_CurTrans[5]);
      ensures ((((((0 == buch_CurStates[0]) && (0 == buch_CurStates[1])) &&
                 (0 == buch_CurStates[2]))
                && (0 == buch_CurStates[3]))
               && (0 == buch_CurStates[4]))
              && (0 == buch_CurStates[5]));
      ensures (0 != buch_CurStates[6]);
      */
int main(void) 
{ int __retres ;
  
  {if (rr < 5000) {goto L;}
  
  {buch_CurOperation = op_opc;
  buch_CurOpStatus = buch_Called;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  opc();}
  
  L4: 
  goto L5;
  L: ;
  {buch_CurOperation = op_opa;
  buch_CurOpStatus = buch_Called;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = 0;
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = buch_CurStates_old[1];
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = buch_CurStates_old[1];
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = 0;
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  opa();}
  
  goto L2;
  {buch_CurOperation = op_opc;
  buch_CurOpStatus = buch_Called;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  opc();}
  
  L6: 
  __retres = 1;
  goto return_label;
  L3: 
  goto L4;
  {buch_CurOperation = op_opc;
  buch_CurOpStatus = buch_Called;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  opc();}
  
  goto L2;
  L2: 
  goto L3;
  L5: ;
  {buch_CurOperation = op_opb;
  buch_CurOpStatus = buch_Called;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = 0;
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  opb();}
  
  goto L6;
  return_label: /* CIL Label */ 
  {buch_CurOperation = op_main;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[6] = buch_CurStates[6];
  buch_CurStates_old[5] = buch_CurStates[5];
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[4] = buch_CurStates[4];
  buch_CurStates_old[3] = buch_CurStates[3];
  buch_CurStates_old[2] = buch_CurStates[2];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[6] = buch_CurStates_old[6] || buch_CurStates_old[5];
  buch_CurStates[5] = 0;
  buch_CurStates[0] = 0;
  buch_CurStates[4] = buch_CurStates_old[3];
  buch_CurStates[3] = buch_CurStates_old[2];
  buch_CurStates[2] = 0;
  buch_CurStates[1] = 0;
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = 0;
  buch_CurTrans[2] = buch_CurStates_old[2];
  buch_CurTrans[3] = buch_CurStates_old[3];
  buch_CurTrans[4] = 0;
  buch_CurTrans[5] = buch_CurStates_old[5];
  buch_CurTrans[6] = buch_CurStates_old[6];
  buch_CurTrans_tmp[0] = buch_CurTrans[0];
  buch_CurTrans_tmp[1] = buch_CurTrans[1];
  buch_CurTrans_tmp[2] = buch_CurTrans[2];
  buch_CurTrans_tmp[3] = buch_CurTrans[3];
  buch_CurTrans_tmp[4] = buch_CurTrans[4];
  buch_CurTrans_tmp[5] = buch_CurTrans[5];
  buch_CurTrans_tmp[6] = buch_CurTrans[6];
  return (__retres);}
  }

}
